HDU 1079 Calendar Game (博弈论-sg)

Calendar Game

Problem Description

Adam and Eve enter this year’s ACM International Collegiate Programming Contest. Last night, they played the Calendar Game, in celebration of this contest. This game consists of the dates from January 1, 1900 to November 4, 2001, the contest day. The game starts
by randomly choosing a date from this interval. Then, the players, Adam and Eve, make moves in their turn with Adam moving first: Adam, Eve, Adam, Eve, etc. There is only one rule for moves and it is simple: from a current date, a player in his/her turn can
move either to the next calendar date or the same day of the next month. When the next month does not have the same day, the player moves only to the next calendar date. For example, from December 19, 1924, you can move either to December 20, 1924, the next
calendar date, or January 19, 1925, the same day of the next month. From January 31 2001, however, you can move only to February 1, 2001, because February 31, 2001 is invalid.

A player wins the game when he/she exactly reaches the date of November 4, 2001. If a player moves to a date after November 4, 2001, he/she looses the game.

Write a program that decides whether, given an initial date, Adam, the first mover, has a winning strategy.

For this game, you need to identify leap years, where February has 29 days. In the Gregorian calendar, leap years occur in years exactly divisible by four. So, 1993, 1994, and 1995 are not leap years, while 1992 and 1996 are leap years. Additionally, the years
ending with 00 are leap years only if they are divisible by 400. So, 1700, 1800, 1900, 2100, and 2200 are not leap years, while 1600, 2000, and 2400 are leap years.

Input

The input consists of T test cases. The number of test cases (T) is given in the first line of the input. Each test case is written in a line and corresponds to an initial date. The three integers in a line, YYYY MM DD, represent the date of the DD-th day of
MM-th month in the year of YYYY. Remember that initial dates are randomly chosen from the interval between January 1, 1900 and November 4, 2001.

Output

Print exactly one line for each test case. The line should contain the answer "YES" or "NO" to the question of whether Adam has a winning strategy against Eve. Since we have T test cases, your program should output totally T lines of "YES" or "NO".

Sample Input

3
2001 11 3
2001 11 2
2001 10 3 

Sample Output

YES
NO
NO 

Source

Asia 2001, Taejon (South Korea)

题目大意:

给定日期,轮流来,可以在日期的月上加1,或者在天数上加1 ,如果约数上加1无效,自动转化为在天数上加1,轮流来,问先手是否赢?

解题思路:

这很明显是道博弈题,对于SG的性质定义

必胜态记为P,用数值0表示,当且仅当其后继都是 N,也就是SG()>0

必输态记为N,用数值1表示,当且仅当其后继存在P,也就是SG()=0

对于这题,完全没必要这样用SG去推理,可以结合DP,用记忆化搜索划分为子问题,每一步取对自己最优的。

解题代码:

#include <iostream>
#include <cstdio>
#include <cstring>
using namespace std;

int dp[2100][15][40][2];
const int day[]={0,31,28,31,30,31,30,31,31,30,31,30,31};

int getday(int y,int m){
    if(m!=2) return day[m];
    else{
        if( ( y%4==0 && y%100!=0 ) || y%400==0 ) return day[m]+1;
        else return day[m];
    }
}

bool valid(int y,int m,int d){
    if(m>12){
        m=1;
        y++;
    }
    if( y>2001 || ( y==2001 && m>11 ) || (y==2001 && m==11 && d>4) || d>getday(y,m) ) return false;
    else return true;
}

int DP(int y,int m,int d,int f){
    if(m>12){
        m=1;
        y++;
    }
    if(getday(y,m)<d){
        d=1;
        m++;
        if(m>12){
            m=1;
            y++;
        }
    }

    if(y>=2001 && m>=11 && d>=4) return 1-f;
    if(dp[y][m][d][f]!=-1) return dp[y][m][d][f];

    int ans;
    if(f==0){
        ans=1;
        if( valid(y,m+1,d) && DP(y,m+1,d,1-f)<ans ) ans=DP(y,m+1,d,1-f);
        if( DP(y,m,d+1,1-f)<ans ) ans=DP(y,m,d+1,1-f);
    }else{
        ans=0;
        if( valid(y,m+1,d) && DP(y,m+1,d,1-f)>ans ) ans=DP(y,m+1,d,1-f);
        if( DP(y,m,d+1,1-f)>ans ) ans=DP(y,m,d+1,1-f);
    }
    return dp[y][m][d][f]=ans;
}

int main(){
    memset(dp,-1,sizeof(dp));
    int t,y,m,d;
    cin>>t;
    while(t-- >0){
        cin>>y>>m>>d;
        if ( DP(y,m,d,0) ) cout<<"NO"<<endl;
        else cout<<"YES"<<endl;
    }
    return 0;
}

HDU 1079 Calendar Game (博弈论-sg)

时间: 2024-08-13 04:11:10

HDU 1079 Calendar Game (博弈论-sg)的相关文章

hdu 1079 Calendar Game sg函数

Calendar Game Time Limit: 5000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 2766    Accepted Submission(s): 1594 Problem Description Adam and Eve enter this year’s ACM International Collegiate Programming Con

HDU 1079 Calendar Game(博弈找规律)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1079 题目大意:给你一个日期(包含年月日),这里我表示成year,month,day,两人轮流操作,每次操作可以将month+1但是,如果下月没有对应的day则只能对day+1(超过该月日数就进入下月一日),或者就day+1.谁最后到达2001.11.4这个日期就是胜者,问先手的人是否能获胜. 解题思路:这个就用上面的P/N分析,一个个月份日期对应的标记上P或N(很快会发现规律只用找每月特定几天),

HDU 1079 Calendar Game(规律博弈)

题目链接:https://cn.vjudge.net/problem/HDU-1079 题目: Adam and Eve enter this year's ACM International Collegiate Programming Contest. Last night, they played the Calendar Game, in celebration of this contest. This game consists of the dates from January 1

hdu 1079 Calendar Game

题目:输入年月日,可以进行两种操作 1.月份加一 2.日期加一 谁最先到 2001 年11月4 日 获胜 思路:此题为找规律博弈 取决于奇偶性 我们新定义一个数 sum,其中sum 等于 月份加上日期 比如 样例 2001 11 3 则 sum=11+3=14 当sum为偶数时,我们无论进行哪种操作,都必然会变为奇数 当sum为奇数时,除了9月30日和11月30会变成奇数外,其余情况都会变成偶数 那么必胜态为 (d+m)%2==0||(d==9&&m==30)||(d==11&&a

poj 1079 Calendar Game(博弈论 SG)

Calendar Game Time Limit: 5000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 2519    Accepted Submission(s): 1438 Problem Description Adam and Eve enter this year's ACM International Collegiate Programming Co

HDU 1847 Good Luck in CET-4 Everybody! (博弈论sg)

Good Luck in CET-4 Everybody! Problem Description 大学英语四级考试就要来临了,你是不是在紧张的复习?也许紧张得连短学期的ACM都没工夫练习了,反正我知道的Kiki和Cici都是如此.当然,作为在考场浸润了十几载的当代大学生,Kiki和Cici更懂得考前的放松,所谓"张弛有道"就是这个意思.这不,Kiki和Cici在每天晚上休息之前都要玩一会儿扑克牌以放松神经. "升级"?"双扣"?"红五

hdu 1079 (SG博弈)

Calendar Game Time Limit: 5000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 2833    Accepted Submission(s): 1636 Problem Description Adam and Eve enter this year's ACM International Collegiate Programming Co

HDU 2897 邂逅明下(SG博弈论)

题目地址:HDU 2897 本来这题可以用NP状态转换,但是数据太大,所以可以通过打表sg函数值,来找出规律.感觉sg函数打表就是利用的NP状态转换的那两条规则. 通过打表可以发现,从1开始,连续p个0,然后接着连续q个正整数,然后再连续p个0,接着连续q个正整数,就这样循环下去.所以规律就很明显了. 代码如下: #include <iostream> #include <cstdio> #include <string> #include <cstring>

博弈论 SG函数(模板) HDU 1848 Fibonacci again and again

Fibonacci again and again Time Limit: 1000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 9296    Accepted Submission(s): 3893 Problem Description 任何一个大学生对菲波那契数列(Fibonacci numbers)应该都不会陌生,它是这样定义的:F(1)=1;F(2)=2;